proc waitresponse {} {
global temp user nick thread
  set temp ""
  addExt -from "$user" -nick "$nick" -thread "$thread" -exttag "xox" -extvals {"command" "accept"} -command {set temp "accept"}
  tkwait variable temp
  delExt -from "$user" -nick "$nick" -thread "$thread" -exttag "xox" -extvals {"command" "accept"}
}

proc makeenabled {} {
  if {[.xox.f.b1 cget -image]==""} {.xox.f.b1 configure -state normal}
  if {[.xox.f.b2 cget -image]==""} {.xox.f.b2 configure -state normal}
  if {[.xox.f.b3 cget -image]==""} {.xox.f.b3 configure -state normal}
  if {[.xox.f.b4 cget -image]==""} {.xox.f.b4 configure -state normal}
  if {[.xox.f.b5 cget -image]==""} {.xox.f.b5 configure -state normal}
  if {[.xox.f.b6 cget -image]==""} {.xox.f.b6 configure -state normal}
  if {[.xox.f.b7 cget -image]==""} {.xox.f.b7 configure -state normal}
  if {[.xox.f.b8 cget -image]==""} {.xox.f.b8 configure -state normal}
  if {[.xox.f.b9 cget -image]==""} {.xox.f.b9 configure -state normal}
}

proc makedisabled {} {
  .xox.f.b1 configure -state disabled
  .xox.f.b2 configure -state disabled
  .xox.f.b3 configure -state disabled
  .xox.f.b4 configure -state disabled
  .xox.f.b5 configure -state disabled
  .xox.f.b6 configure -state disabled
  .xox.f.b7 configure -state disabled
  .xox.f.b8 configure -state disabled
  .xox.f.b9 configure -state disabled
}

proc controlclicks {abc} {
  set found 0
  set b1 [.xox.f.b1 cget -image]
  set b2 [.xox.f.b2 cget -image]
  set b3 [.xox.f.b3 cget -image]
  set b4 [.xox.f.b4 cget -image]
  set b5 [.xox.f.b5 cget -image]
  set b6 [.xox.f.b6 cget -image]
  set b7 [.xox.f.b7 cget -image]
  set b8 [.xox.f.b8 cget -image]
  set b9 [.xox.f.b9 cget -image]

  if {$b1==$abc && $b2==$abc && $b3==$abc} {set found 1; .xox.f.b1 configure -bg #FF0000; .xox.f.b2 configure -bg #FF0000; .xox.f.b3 configure -bg #FF0000}
  if {$b4==$abc && $b5==$abc && $b6==$abc} {set found 1; .xox.f.b4 configure -bg #FF0000; .xox.f.b5 configure -bg #FF0000; .xox.f.b6 configure -bg #FF0000}
  if {$b7==$abc && $b8==$abc && $b9==$abc} {set found 1; .xox.f.b7 configure -bg #FF0000; .xox.f.b8 configure -bg #FF0000; .xox.f.b9 configure -bg #FF0000}

  if {$b1==$abc && $b4==$abc && $b7==$abc} {set found 1; .xox.f.b1 configure -bg #FF0000; .xox.f.b4 configure -bg #FF0000; .xox.f.b7 configure -bg #FF0000}
  if {$b2==$abc && $b5==$abc && $b8==$abc} {set found 1; .xox.f.b2 configure -bg #FF0000; .xox.f.b5 configure -bg #FF0000; .xox.f.b8 configure -bg #FF0000}
  if {$b3==$abc && $b6==$abc && $b9==$abc} {set found 1; .xox.f.b3 configure -bg #FF0000; .xox.f.b6 configure -bg #FF0000; .xox.f.b9 configure -bg #FF0000}

  if {$b1==$abc && $b5==$abc && $b9==$abc} {set found 1; .xox.f.b1 configure -bg #FF0000; .xox.f.b5 configure -bg #FF0000; .xox.f.b9 configure -bg #FF0000}
  if {$b3==$abc && $b5==$abc && $b7==$abc} {set found 1; .xox.f.b3 configure -bg #FF0000; .xox.f.b5 configure -bg #FF0000; .xox.f.b7 configure -bg #FF0000}

  if {$found && $abc=="x"} {makedisabled; tk_messageBox -title "Winner!" -message "You won!"; return -code return} \
    elseif {$found && $abc=="o"} {makedisabled; tk_messageBox -title "Loser!" -message "You lost!"; return -code return}

#
# Here we control if playing table is finished...
#
  set finish 1
  if {[.xox.f.b1 cget -image]==""} {set finish 0}
  if {[.xox.f.b2 cget -image]==""} {set finish 0}
  if {[.xox.f.b3 cget -image]==""} {set finish 0}
  if {[.xox.f.b4 cget -image]==""} {set finish 0}
  if {[.xox.f.b5 cget -image]==""} {set finish 0}
  if {[.xox.f.b6 cget -image]==""} {set finish 0}
  if {[.xox.f.b7 cget -image]==""} {set finish 0}
  if {[.xox.f.b8 cget -image]==""} {set finish 0}
  if {[.xox.f.b9 cget -image]==""} {set finish 0}

  if {$finish} {makedisabled; tk_messageBox -title "XOX" -message "Neither side wins..."; return -code return}
}

proc waituser {} {
global temp thread user nick
  set temp ""
  tkwait variable temp
  sendMessage -to "$user" -nick "$nick" -thread "$thread" -exttag "xox" -extvals {"command" "click"} -exttxt "$temp"
}

proc waitclick {} {
global temp thread user nick

  addExt -from "$user" -nick "$nick" -thread "$thread" -exttag "xox" -extvals {"command" "click"} -command {set temp "%EXTTXT"}
  tkwait variable temp
  delExt -from "$user" -nick "$nick" -thread "$thread" -exttag "xox" -extvals {"command" "click"}

  switch -- $temp {
	1 {if {[.xox.f.b1 cget -image]!=""} {tk_messageBox -title "TicTacToe!" -message "An internal error occured!"; exit}
	   .xox.f.b1 configure -image o}
	2 {if {[.xox.f.b2 cget -image]!=""} {tk_messageBox -title "TicTacToe!" -message "An internal error occured!"; exit}
	   .xox.f.b2 configure -image o}
	3 {if {[.xox.f.b3 cget -image]!=""} {tk_messageBox -title "TicTacToe!" -message "An internal error occured!"; exit}
	   .xox.f.b3 configure -image o}
	4 {if {[.xox.f.b4 cget -image]!=""} {tk_messageBox -title "TicTacToe!" -message "An internal error occured!"; exit}
	   .xox.f.b4 configure -image o}
	5 {if {[.xox.f.b5 cget -image]!=""} {tk_messageBox -title "TicTacToe!" -message "An internal error occured!"; exit}
	   .xox.f.b5 configure -image o}
	6 {if {[.xox.f.b6 cget -image]!=""} {tk_messageBox -title "TicTacToe!" -message "An internal error occured!"; exit}
	   .xox.f.b6 configure -image o}
	7 {if {[.xox.f.b7 cget -image]!=""} {tk_messageBox -title "TicTacToe!" -message "An internal error occured!"; exit}
	   .xox.f.b7 configure -image o}
	8 {if {[.xox.f.b8 cget -image]!=""} {tk_messageBox -title "TicTacToe!" -message "An internal error occured!"; exit}
	   .xox.f.b8 configure -image o}
	9 {if {[.xox.f.b9 cget -image]!=""} {tk_messageBox -title "TicTacToe!" -message "An internal error occured!"; exit}
	   .xox.f.b9 configure -image o}
	default {tk_messageBox -title "TicTacToe!" -message "An internal error occured!"; exit}
  }
}

proc initgfx {} {
	image create bitmap x -data {
		#define x_width 40
		#define x_height 40
		static char x_bits[] = {
		 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xf0,0x03,0x00,0x00,0x00,
		 0xf0,0x03,0x00,0x00,0x00,0xfc,0x0f,0x00,0x00,0x00,0xfc,0x0f,0x00,0x00,0x00,
		 0xfc,0x3f,0x00,0xfc,0x03,0xfc,0x3f,0x00,0xfc,0x03,0xf0,0xff,0x00,0xff,0x0f,
		 0xf0,0xff,0x00,0xff,0x0f,0xf0,0xff,0xc3,0xff,0x0f,0xf0,0xff,0xc3,0xff,0x0f,
		 0xc0,0xff,0xf3,0xff,0x0f,0xc0,0xff,0xf3,0xff,0x0f,0x00,0xff,0xff,0xff,0x03,
		 0x00,0xff,0xff,0xff,0x03,0x00,0xff,0xff,0x3f,0x00,0x00,0xff,0xff,0x3f,0x00,
		 0x00,0xfc,0xff,0x0f,0x00,0x00,0xfc,0xff,0x0f,0x00,0x00,0xf0,0xff,0x03,0x00,
		 0x00,0xf0,0xff,0x03,0x00,0x00,0xfc,0xff,0x03,0x00,0x00,0xfc,0xff,0x03,0x00,
		 0x00,0xff,0xff,0x0f,0x00,0x00,0xff,0xff,0x0f,0x00,0xc0,0xff,0xff,0xff,0x00,
		 0xc0,0xff,0xff,0xff,0x00,0xf0,0xff,0xff,0xff,0x03,0xf0,0xff,0xff,0xff,0x03,
		 0xfc,0xff,0xf0,0xff,0x0f,0xfc,0xff,0xf0,0xff,0x0f,0xfc,0x3f,0xc0,0xff,0x0f,
		 0xfc,0x3f,0xc0,0xff,0x0f,0xfc,0x0f,0x00,0xff,0x0f,0xfc,0x0f,0x00,0xff,0x0f,
		 0xf0,0x03,0x00,0xf0,0x03,0xf0,0x03,0x00,0xf0,0x03,0x00,0x00,0x00,0x00,0x00,
		 0x00,0x00,0x00,0x00,0x00};
	}

	image create bitmap o -data {
		#define o_width 40
		#define o_height 40
		static char o_bits[] = {
		 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0x00,0x00,0x00,0x00,0xff,0x00,0x00,
		 0x00,0xf0,0xff,0x0f,0x00,0x00,0xf0,0xff,0x0f,0x00,0x00,0xfc,0xff,0x3f,0x00,
		 0x00,0xfc,0xff,0x3f,0x00,0x00,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0x00,
		 0xc0,0xff,0xff,0xff,0x03,0xc0,0xff,0xff,0xff,0x03,0xc0,0xff,0xc3,0xff,0x03,
		 0xc0,0xff,0xc3,0xff,0x03,0xf0,0xff,0x00,0xff,0x0f,0xf0,0xff,0x00,0xff,0x0f,
		 0xf0,0x3f,0x00,0xfc,0x0f,0xf0,0x3f,0x00,0xfc,0x0f,0xf0,0x3f,0x00,0xfc,0x0f,
		 0xf0,0x3f,0x00,0xfc,0x0f,0xf0,0x3f,0x00,0xfc,0x0f,0xf0,0x3f,0x00,0xfc,0x0f,
		 0xf0,0xff,0x00,0xff,0x0f,0xf0,0xff,0x00,0xff,0x0f,0xc0,0xff,0xff,0xff,0x03,
		 0xc0,0xff,0xff,0xff,0x03,0xc0,0xff,0xff,0xff,0x03,0xc0,0xff,0xff,0xff,0x03,
		 0x00,0xff,0xff,0xff,0x00,0x00,0xff,0xff,0xff,0x00,0x00,0xfc,0xff,0x3f,0x00,
		 0x00,0xfc,0xff,0x3f,0x00,0x00,0xc0,0xff,0x03,0x00,0x00,0xc0,0xff,0x03,0x00,
		 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		 0x00,0x00,0x00,0x00,0x00};
	}
}

proc xoxwin {} {
	toplevel .xox -class toplevel
	wm focusmodel .xox passive
	wm geometry .xox 152x168
	wm overrideredirect .xox 0
	wm resizable .xox 0 0
	wm deiconify .xox
	wm title .xox "TicTacToe"
	wm withdraw .xox

	frame  .xox.f -bd 1 -relief sunken
	label  .xox.l -bd 1 -relief sunken
	button .xox.f.b1 -bd 1 -state disabled -command {.xox.f.b1 configure -image x; set temp "1"}
	button .xox.f.b2 -bd 1 -state disabled -command {.xox.f.b2 configure -image x; set temp "2"}
	button .xox.f.b3 -bd 1 -state disabled -command {.xox.f.b3 configure -image x; set temp "3"}
	button .xox.f.b4 -bd 1 -state disabled -command {.xox.f.b4 configure -image x; set temp "4"}
	button .xox.f.b5 -bd 1 -state disabled -command {.xox.f.b5 configure -image x; set temp "5"}
	button .xox.f.b6 -bd 1 -state disabled -command {.xox.f.b6 configure -image x; set temp "6"}
	button .xox.f.b7 -bd 1 -state disabled -command {.xox.f.b7 configure -image x; set temp "7"}
	button .xox.f.b8 -bd 1 -state disabled -command {.xox.f.b8 configure -image x; set temp "8"}
	button .xox.f.b9 -bd 1 -state disabled -command {.xox.f.b9 configure -image x; set temp "9"}

	pack .xox.f -fill both -expand 1
	pack .xox.l -fill x
	place .xox.f.b1 -x   0 -y   0 -width 50 -height 50
	place .xox.f.b2 -x  50 -y   0 -width 50 -height 50
	place .xox.f.b3 -x 100 -y   0 -width 50 -height 50
	place .xox.f.b4 -x   0 -y  50 -width 50 -height 50
	place .xox.f.b5 -x  50 -y  50 -width 50 -height 50
	place .xox.f.b6 -x 100 -y  50 -width 50 -height 50
	place .xox.f.b7 -x   0 -y 100 -width 50 -height 50
	place .xox.f.b8 -x  50 -y 100 -width 50 -height 50
	place .xox.f.b9 -x 100 -y 100 -width 50 -height 50
}

set temp ""

wm withdraw .
initgfx
xoxwin

switch -- "[lindex $argv 0]" {
      incoming {set thread [lindex $argv 1]
		set user [lindex $argv 2]
		set nick [lindex $argv 3]
		if {[tk_messageBox -message "$user ($nick) wants to play\nTicTacToe. Do you accept?" -type "yesno"]=="no"} {sendMessage -to "$user" -nick "$nick" -thread "$thread" -exttag "xox" -extvals {"command" "cancel"};exit}
		addExt -from "$user" -nick "$nick" -thread "$thread" -exttag "xox" -extvals {"command" "cancel"} -command {tk_messageBox -title "Sorry..." -message "$user ($nick) doesn't want to play..."; exit}
		sendMessage -to "$user" -nick "$nick" -thread "$thread" -exttag "xox" -extvals {"command" "accept"}
		wm deiconify .xox
		while {1} {
			makedisabled
			.xox.l configure -text "Opponent's turn..."
			waitclick
			controlclicks "o"
			makeenabled
			.xox.l configure -text "Your turn..."
			waituser
			controlclicks "x"
		}
	       }
      outgoing {set user [lindex $argv 1]
		set nick [lindex $argv 2]
		set thread "Game#[clock seconds]+$user+$nick+[expr rand()*100]"
		wm deiconify .xox
		.xox.l configure -text "Waiting for response..."
		sendMessage -to "$user" -nick "$nick" -thread "$thread" -exttag "xox" -extvals {"command" "request"}
		addExt -from "$user" -nick "$nick" -thread "$thread" -exttag "xox" -extvals {"command" "cancel"} -command {tk_messageBox -title "Sorry..." -message "$user ($nick) doesn't want to play..."; exit}
		waitresponse
		while {1} {
			makeenabled
			.xox.l configure -text "Your turn..."
			waituser
			controlclicks "x"
			makedisabled
			.xox.l configure -text "Opponent's turn..."
			waitclick
			controlclicks "o"
		}
	       }
      default  {exit}
}
